# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAppSecCustomDenyResult',
    'AwaitableGetAppSecCustomDenyResult',
    'get_app_sec_custom_deny',
    'get_app_sec_custom_deny_output',
]

@pulumi.output_type
class GetAppSecCustomDenyResult:
    """
    A collection of values returned by getAppSecCustomDeny.
    """
    def __init__(__self__, config_id=None, custom_deny_id=None, id=None, json=None, output_text=None):
        if config_id and not isinstance(config_id, int):
            raise TypeError("Expected argument 'config_id' to be a int")
        pulumi.set(__self__, "config_id", config_id)
        if custom_deny_id and not isinstance(custom_deny_id, str):
            raise TypeError("Expected argument 'custom_deny_id' to be a str")
        pulumi.set(__self__, "custom_deny_id", custom_deny_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if json and not isinstance(json, str):
            raise TypeError("Expected argument 'json' to be a str")
        pulumi.set(__self__, "json", json)
        if output_text and not isinstance(output_text, str):
            raise TypeError("Expected argument 'output_text' to be a str")
        pulumi.set(__self__, "output_text", output_text)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> int:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="customDenyId")
    def custom_deny_id(self) -> Optional[str]:
        return pulumi.get(self, "custom_deny_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def json(self) -> str:
        return pulumi.get(self, "json")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> str:
        return pulumi.get(self, "output_text")


class AwaitableGetAppSecCustomDenyResult(GetAppSecCustomDenyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppSecCustomDenyResult(
            config_id=self.config_id,
            custom_deny_id=self.custom_deny_id,
            id=self.id,
            json=self.json,
            output_text=self.output_text)


def get_app_sec_custom_deny(config_id: Optional[int] = None,
                            custom_deny_id: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppSecCustomDenyResult:
    """
    **Scopes**: Security configuration; custom deny

    Returns information about custom deny actions. Custom denies allow you to craft your own error messages or redirect pages to use when HTTP requests are denied.

    **Related API Endpoint**: [/appsec/v1/configs/{configId}/versions/{versionNumber}/custom-deny](https://techdocs.akamai.com/application-security/reference/get-custom-deny-actions)

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name="Documentation")
    custom_deny_list = akamai.get_app_sec_custom_deny(config_id=configuration.config_id)
    pulumi.export("customDenyListOutput", custom_deny_list.output_text)
    pulumi.export("customDenyListJson", custom_deny_list.json)
    custom_deny = akamai.get_app_sec_custom_deny(config_id=configuration.config_id,
        custom_deny_id="deny_custom_64386")
    pulumi.export("customDenyJson", custom_deny.json)
    pulumi.export("customDenyOutput", custom_deny.output_text)
    ```
    ## Output Options

    The following options can be used to determine the information returned, and how that returned information is formatted:

    - `json`. JSON-formatted list of custom deny information.
    - `output_text`. Tabular report of the custom deny information.


    :param int config_id: . Unique identifier of the security configuration associated with the custom denies.
    :param str custom_deny_id: . Unique identifier of the custom deny you want to return information for. If not included. information is returned for all your custom denies.
    """
    __args__ = dict()
    __args__['configId'] = config_id
    __args__['customDenyId'] = custom_deny_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('akamai:index/getAppSecCustomDeny:getAppSecCustomDeny', __args__, opts=opts, typ=GetAppSecCustomDenyResult).value

    return AwaitableGetAppSecCustomDenyResult(
        config_id=__ret__.config_id,
        custom_deny_id=__ret__.custom_deny_id,
        id=__ret__.id,
        json=__ret__.json,
        output_text=__ret__.output_text)


@_utilities.lift_output_func(get_app_sec_custom_deny)
def get_app_sec_custom_deny_output(config_id: Optional[pulumi.Input[int]] = None,
                                   custom_deny_id: Optional[pulumi.Input[Optional[str]]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAppSecCustomDenyResult]:
    """
    **Scopes**: Security configuration; custom deny

    Returns information about custom deny actions. Custom denies allow you to craft your own error messages or redirect pages to use when HTTP requests are denied.

    **Related API Endpoint**: [/appsec/v1/configs/{configId}/versions/{versionNumber}/custom-deny](https://techdocs.akamai.com/application-security/reference/get-custom-deny-actions)

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name="Documentation")
    custom_deny_list = akamai.get_app_sec_custom_deny(config_id=configuration.config_id)
    pulumi.export("customDenyListOutput", custom_deny_list.output_text)
    pulumi.export("customDenyListJson", custom_deny_list.json)
    custom_deny = akamai.get_app_sec_custom_deny(config_id=configuration.config_id,
        custom_deny_id="deny_custom_64386")
    pulumi.export("customDenyJson", custom_deny.json)
    pulumi.export("customDenyOutput", custom_deny.output_text)
    ```
    ## Output Options

    The following options can be used to determine the information returned, and how that returned information is formatted:

    - `json`. JSON-formatted list of custom deny information.
    - `output_text`. Tabular report of the custom deny information.


    :param int config_id: . Unique identifier of the security configuration associated with the custom denies.
    :param str custom_deny_id: . Unique identifier of the custom deny you want to return information for. If not included. information is returned for all your custom denies.
    """
    ...
