# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAppSecMatchTargetsResult',
    'AwaitableGetAppSecMatchTargetsResult',
    'get_app_sec_match_targets',
    'get_app_sec_match_targets_output',
]

@pulumi.output_type
class GetAppSecMatchTargetsResult:
    """
    A collection of values returned by getAppSecMatchTargets.
    """
    def __init__(__self__, config_id=None, id=None, json=None, match_target_id=None, output_text=None):
        if config_id and not isinstance(config_id, int):
            raise TypeError("Expected argument 'config_id' to be a int")
        pulumi.set(__self__, "config_id", config_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if json and not isinstance(json, str):
            raise TypeError("Expected argument 'json' to be a str")
        pulumi.set(__self__, "json", json)
        if match_target_id and not isinstance(match_target_id, int):
            raise TypeError("Expected argument 'match_target_id' to be a int")
        pulumi.set(__self__, "match_target_id", match_target_id)
        if output_text and not isinstance(output_text, str):
            raise TypeError("Expected argument 'output_text' to be a str")
        pulumi.set(__self__, "output_text", output_text)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> int:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def json(self) -> str:
        return pulumi.get(self, "json")

    @property
    @pulumi.getter(name="matchTargetId")
    def match_target_id(self) -> Optional[int]:
        return pulumi.get(self, "match_target_id")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> str:
        return pulumi.get(self, "output_text")


class AwaitableGetAppSecMatchTargetsResult(GetAppSecMatchTargetsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppSecMatchTargetsResult(
            config_id=self.config_id,
            id=self.id,
            json=self.json,
            match_target_id=self.match_target_id,
            output_text=self.output_text)


def get_app_sec_match_targets(config_id: Optional[int] = None,
                              match_target_id: Optional[int] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppSecMatchTargetsResult:
    """
    **Scopes**: Security configuration; match target

    Returns information about your match targets. Match targets determine which security policy should apply to an API, hostname, or path.

    **Related API Endpoint**: [/appsec/v1/configs/{configId}/versions/{versionNumber}/match-targets{?policyId,includeChildObjectName}](https://techdocs.akamai.com/application-security/reference/get-match-targets)

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name="Documentation")
    match_targets_app_sec_match_targets = akamai.get_app_sec_match_targets(config_id=configuration.config_id)
    pulumi.export("matchTargets", match_targets_app_sec_match_targets.output_text)
    match_target = akamai.get_app_sec_match_targets(config_id=configuration.config_id,
        match_target_id=2712938)
    pulumi.export("matchTargetOutput", match_target.output_text)
    ```
    ## Output Options

    The following options can be used to determine the information returned, and how that returned information is formatted:

    - `output_text`. Tabular report showing the ID and security policy ID of your match targets.
    - `json`. JSON-formatted list of the match target information.


    :param int config_id: . Unique identifier of the security configuration associated with the match targets.
    :param int match_target_id: . Unique identifier of the match target you want to return information for. If not included, information is returned for all your match targets.
    """
    __args__ = dict()
    __args__['configId'] = config_id
    __args__['matchTargetId'] = match_target_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('akamai:index/getAppSecMatchTargets:getAppSecMatchTargets', __args__, opts=opts, typ=GetAppSecMatchTargetsResult).value

    return AwaitableGetAppSecMatchTargetsResult(
        config_id=__ret__.config_id,
        id=__ret__.id,
        json=__ret__.json,
        match_target_id=__ret__.match_target_id,
        output_text=__ret__.output_text)


@_utilities.lift_output_func(get_app_sec_match_targets)
def get_app_sec_match_targets_output(config_id: Optional[pulumi.Input[int]] = None,
                                     match_target_id: Optional[pulumi.Input[Optional[int]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAppSecMatchTargetsResult]:
    """
    **Scopes**: Security configuration; match target

    Returns information about your match targets. Match targets determine which security policy should apply to an API, hostname, or path.

    **Related API Endpoint**: [/appsec/v1/configs/{configId}/versions/{versionNumber}/match-targets{?policyId,includeChildObjectName}](https://techdocs.akamai.com/application-security/reference/get-match-targets)

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name="Documentation")
    match_targets_app_sec_match_targets = akamai.get_app_sec_match_targets(config_id=configuration.config_id)
    pulumi.export("matchTargets", match_targets_app_sec_match_targets.output_text)
    match_target = akamai.get_app_sec_match_targets(config_id=configuration.config_id,
        match_target_id=2712938)
    pulumi.export("matchTargetOutput", match_target.output_text)
    ```
    ## Output Options

    The following options can be used to determine the information returned, and how that returned information is formatted:

    - `output_text`. Tabular report showing the ID and security policy ID of your match targets.
    - `json`. JSON-formatted list of the match target information.


    :param int config_id: . Unique identifier of the security configuration associated with the match targets.
    :param int match_target_id: . Unique identifier of the match target you want to return information for. If not included, information is returned for all your match targets.
    """
    ...
