# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAppSecReputationProfilesResult',
    'AwaitableGetAppSecReputationProfilesResult',
    'get_app_sec_reputation_profiles',
    'get_app_sec_reputation_profiles_output',
]

@pulumi.output_type
class GetAppSecReputationProfilesResult:
    """
    A collection of values returned by getAppSecReputationProfiles.
    """
    def __init__(__self__, config_id=None, id=None, json=None, output_text=None, reputation_profile_id=None):
        if config_id and not isinstance(config_id, int):
            raise TypeError("Expected argument 'config_id' to be a int")
        pulumi.set(__self__, "config_id", config_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if json and not isinstance(json, str):
            raise TypeError("Expected argument 'json' to be a str")
        pulumi.set(__self__, "json", json)
        if output_text and not isinstance(output_text, str):
            raise TypeError("Expected argument 'output_text' to be a str")
        pulumi.set(__self__, "output_text", output_text)
        if reputation_profile_id and not isinstance(reputation_profile_id, int):
            raise TypeError("Expected argument 'reputation_profile_id' to be a int")
        pulumi.set(__self__, "reputation_profile_id", reputation_profile_id)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> int:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def json(self) -> str:
        return pulumi.get(self, "json")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> str:
        return pulumi.get(self, "output_text")

    @property
    @pulumi.getter(name="reputationProfileId")
    def reputation_profile_id(self) -> Optional[int]:
        return pulumi.get(self, "reputation_profile_id")


class AwaitableGetAppSecReputationProfilesResult(GetAppSecReputationProfilesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppSecReputationProfilesResult(
            config_id=self.config_id,
            id=self.id,
            json=self.json,
            output_text=self.output_text,
            reputation_profile_id=self.reputation_profile_id)


def get_app_sec_reputation_profiles(config_id: Optional[int] = None,
                                    reputation_profile_id: Optional[int] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppSecReputationProfilesResult:
    """
    **Scopes**: Security configuration; reputation profile

    Returns information about your reputation profiles. Reputation profiles grade the security risk of an IP address based on previous activities associated with that address. Depending on the reputation score, and depending on how your configuration has been set up, requests from a specific IP address can trigger an alert, or even be blocked.

    **Related API Endpoint**: [/appsec/v1/configs/{configId}/versions/{versionNumber}/reputation-profiles](https://techdocs.akamai.com/application-security/reference/get-reputation-profiles)

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name="Documentation")
    reputation_profiles = akamai.get_app_sec_reputation_profiles(config_id=configuration.config_id)
    pulumi.export("reputationProfilesOutput", reputation_profiles.output_text)
    pulumi.export("reputationProfilesJson", reputation_profiles.json)
    reputation_profile = akamai.get_app_sec_reputation_profiles(config_id=configuration.config_id,
        reputation_profile_id=12345)
    pulumi.export("reputationProfileJson", reputation_profile.json)
    pulumi.export("reputationProfileOutput", reputation_profile.output_text)
    ```
    ## Output Options

    The following options can be used to determine the information returned, and how that returned information is formatted:

    - `output_text`. Tabular report of the details about the specified reputation profile or profiles.
    - `json`. JSON-formatted report of the details about the specified reputation profile or profiles.


    :param int config_id: . Unique identifier of the security configuration associated with the reputation profiles.
    :param int reputation_profile_id: . Unique identifier of the reputation profile you want to return information for. If not included, information is returned for all your reputation profiles.
    """
    __args__ = dict()
    __args__['configId'] = config_id
    __args__['reputationProfileId'] = reputation_profile_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('akamai:index/getAppSecReputationProfiles:getAppSecReputationProfiles', __args__, opts=opts, typ=GetAppSecReputationProfilesResult).value

    return AwaitableGetAppSecReputationProfilesResult(
        config_id=__ret__.config_id,
        id=__ret__.id,
        json=__ret__.json,
        output_text=__ret__.output_text,
        reputation_profile_id=__ret__.reputation_profile_id)


@_utilities.lift_output_func(get_app_sec_reputation_profiles)
def get_app_sec_reputation_profiles_output(config_id: Optional[pulumi.Input[int]] = None,
                                           reputation_profile_id: Optional[pulumi.Input[Optional[int]]] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAppSecReputationProfilesResult]:
    """
    **Scopes**: Security configuration; reputation profile

    Returns information about your reputation profiles. Reputation profiles grade the security risk of an IP address based on previous activities associated with that address. Depending on the reputation score, and depending on how your configuration has been set up, requests from a specific IP address can trigger an alert, or even be blocked.

    **Related API Endpoint**: [/appsec/v1/configs/{configId}/versions/{versionNumber}/reputation-profiles](https://techdocs.akamai.com/application-security/reference/get-reputation-profiles)

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name="Documentation")
    reputation_profiles = akamai.get_app_sec_reputation_profiles(config_id=configuration.config_id)
    pulumi.export("reputationProfilesOutput", reputation_profiles.output_text)
    pulumi.export("reputationProfilesJson", reputation_profiles.json)
    reputation_profile = akamai.get_app_sec_reputation_profiles(config_id=configuration.config_id,
        reputation_profile_id=12345)
    pulumi.export("reputationProfileJson", reputation_profile.json)
    pulumi.export("reputationProfileOutput", reputation_profile.output_text)
    ```
    ## Output Options

    The following options can be used to determine the information returned, and how that returned information is formatted:

    - `output_text`. Tabular report of the details about the specified reputation profile or profiles.
    - `json`. JSON-formatted report of the details about the specified reputation profile or profiles.


    :param int config_id: . Unique identifier of the security configuration associated with the reputation profiles.
    :param int reputation_profile_id: . Unique identifier of the reputation profile you want to return information for. If not included, information is returned for all your reputation profiles.
    """
    ...
