# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetDatastreamsResult',
    'AwaitableGetDatastreamsResult',
    'get_datastreams',
    'get_datastreams_output',
]

@pulumi.output_type
class GetDatastreamsResult:
    """
    A collection of values returned by getDatastreams.
    """
    def __init__(__self__, group_id=None, id=None, streams=None):
        if group_id and not isinstance(group_id, str):
            raise TypeError("Expected argument 'group_id' to be a str")
        pulumi.set(__self__, "group_id", group_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if streams and not isinstance(streams, list):
            raise TypeError("Expected argument 'streams' to be a list")
        pulumi.set(__self__, "streams", streams)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> Optional[str]:
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def streams(self) -> Sequence['outputs.GetDatastreamsStreamResult']:
        return pulumi.get(self, "streams")


class AwaitableGetDatastreamsResult(GetDatastreamsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDatastreamsResult(
            group_id=self.group_id,
            id=self.id,
            streams=self.streams)


def get_datastreams(group_id: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDatastreamsResult:
    """
    Use the `get_datastreams` data source to list details about the DataStream configuration.

    ## Attributes reference

    This data source returns these attributes:

    * `streams` - Returns the latest versions of the stream configurations for all groups within in your account. You can use the `group_id` parameter to view the latest versions of all configurations in a specific group.
      * `activation_status` - The activation status of the stream. These are possible values: `ACTIVATED`, `DEACTIVATED`, `ACTIVATING`, `DEACTIVATING`, or `INACTIVE`. See the [Activate a stream](https://techdocs.akamai.com/datastream2/reference/put-stream-activate) and [Deactivate a stream](https://techdocs.akamai.com/datastream2/reference/put-stream-deactivate) operations.
      * `archived` - Whether the stream is archived.
      * `connectors` - The connector where the stream sends logs.
      * `contract_id` - Identifies the contract that the stream is associated with.
      * `created_by` - The user who created the stream.
      * `created_date` - The date and time when the stream was created in this format: `14-07-2020 07:07:40 GMT`.
      * `current_version_id` - Identifies the current version of the stream.
      * `errors` - Objects that may indicate stream failure errors. Learn more about [Errors](https://techdocs.akamai.com/datastream2/reference/errors).
        * `detail` - A message informing about the status of the failed stream.
        * `title` - A descriptive label for the type of error.
        * `type` - Identifies the error type, either `ACTIVATION_ERROR` or `UNEXPECTED_SYSTEM_ERROR`. In case of these errors, contact support for assistance before continuing.
      * `group_id` - Identifies the group where the stream is created.
      * `group_name` - The group name where the stream is created.
      * `properties` - List of properties associated with the stream.
        * `property_id` - The identifier of the property.
        * `property_name` - The descriptive label for the property.
      * `stream_id` - A stream's unique identifier.
      * `stream_name` - The name of the stream.
      * `stream_type_name` - Specifies the type of the data stream. `Logs - Raw` is the only stream type name currently available.
      * `stream_version_id` - A stream version's unique identifier.


    :param str group_id: Unique identifier of the group that can access the product.
    """
    __args__ = dict()
    __args__['groupId'] = group_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('akamai:index/getDatastreams:getDatastreams', __args__, opts=opts, typ=GetDatastreamsResult).value

    return AwaitableGetDatastreamsResult(
        group_id=__ret__.group_id,
        id=__ret__.id,
        streams=__ret__.streams)


@_utilities.lift_output_func(get_datastreams)
def get_datastreams_output(group_id: Optional[pulumi.Input[Optional[str]]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDatastreamsResult]:
    """
    Use the `get_datastreams` data source to list details about the DataStream configuration.

    ## Attributes reference

    This data source returns these attributes:

    * `streams` - Returns the latest versions of the stream configurations for all groups within in your account. You can use the `group_id` parameter to view the latest versions of all configurations in a specific group.
      * `activation_status` - The activation status of the stream. These are possible values: `ACTIVATED`, `DEACTIVATED`, `ACTIVATING`, `DEACTIVATING`, or `INACTIVE`. See the [Activate a stream](https://techdocs.akamai.com/datastream2/reference/put-stream-activate) and [Deactivate a stream](https://techdocs.akamai.com/datastream2/reference/put-stream-deactivate) operations.
      * `archived` - Whether the stream is archived.
      * `connectors` - The connector where the stream sends logs.
      * `contract_id` - Identifies the contract that the stream is associated with.
      * `created_by` - The user who created the stream.
      * `created_date` - The date and time when the stream was created in this format: `14-07-2020 07:07:40 GMT`.
      * `current_version_id` - Identifies the current version of the stream.
      * `errors` - Objects that may indicate stream failure errors. Learn more about [Errors](https://techdocs.akamai.com/datastream2/reference/errors).
        * `detail` - A message informing about the status of the failed stream.
        * `title` - A descriptive label for the type of error.
        * `type` - Identifies the error type, either `ACTIVATION_ERROR` or `UNEXPECTED_SYSTEM_ERROR`. In case of these errors, contact support for assistance before continuing.
      * `group_id` - Identifies the group where the stream is created.
      * `group_name` - The group name where the stream is created.
      * `properties` - List of properties associated with the stream.
        * `property_id` - The identifier of the property.
        * `property_name` - The descriptive label for the property.
      * `stream_id` - A stream's unique identifier.
      * `stream_name` - The name of the stream.
      * `stream_type_name` - Specifies the type of the data stream. `Logs - Raw` is the only stream type name currently available.
      * `stream_version_id` - A stream version's unique identifier.


    :param str group_id: Unique identifier of the group that can access the product.
    """
    ...
