# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAppSecMalwareContentTypesResult',
    'AwaitableGetAppSecMalwareContentTypesResult',
    'get_app_sec_malware_content_types',
    'get_app_sec_malware_content_types_output',
]

@pulumi.output_type
class GetAppSecMalwareContentTypesResult:
    """
    A collection of values returned by getAppSecMalwareContentTypes.
    """
    def __init__(__self__, config_id=None, id=None, json=None, output_text=None):
        if config_id and not isinstance(config_id, int):
            raise TypeError("Expected argument 'config_id' to be a int")
        pulumi.set(__self__, "config_id", config_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if json and not isinstance(json, str):
            raise TypeError("Expected argument 'json' to be a str")
        pulumi.set(__self__, "json", json)
        if output_text and not isinstance(output_text, str):
            raise TypeError("Expected argument 'output_text' to be a str")
        pulumi.set(__self__, "output_text", output_text)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> int:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def json(self) -> str:
        return pulumi.get(self, "json")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> str:
        return pulumi.get(self, "output_text")


class AwaitableGetAppSecMalwareContentTypesResult(GetAppSecMalwareContentTypesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppSecMalwareContentTypesResult(
            config_id=self.config_id,
            id=self.id,
            json=self.json,
            output_text=self.output_text)


def get_app_sec_malware_content_types(config_id: Optional[int] = None,
                                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppSecMalwareContentTypesResult:
    """
    **Scopes**: Security configuration; malware protection

    Returns information about available content types for malware protection. Each malware policy includes a set of content types to which the policy's actions are applied.

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name="Documentation")
    malware_content_types = akamai.get_app_sec_malware_content_types(config_id=configuration.config_id)
    pulumi.export("malwareContentTypesOutput", malware_content_types.output_text)
    pulumi.export("malwareContentTypesJson", malware_content_types.json)
    ```
    ## Output Options

    The following options can be used to determine the information returned, and how that returned information is formatted:

    - `output_text`. Tabular report showing the available content types.
    - `json`. JSON-formatted list of the available content types.


    :param int config_id: . Unique identifier of the security configuration associated with the content types.
    """
    __args__ = dict()
    __args__['configId'] = config_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('akamai:index/getAppSecMalwareContentTypes:getAppSecMalwareContentTypes', __args__, opts=opts, typ=GetAppSecMalwareContentTypesResult).value

    return AwaitableGetAppSecMalwareContentTypesResult(
        config_id=__ret__.config_id,
        id=__ret__.id,
        json=__ret__.json,
        output_text=__ret__.output_text)


@_utilities.lift_output_func(get_app_sec_malware_content_types)
def get_app_sec_malware_content_types_output(config_id: Optional[pulumi.Input[int]] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAppSecMalwareContentTypesResult]:
    """
    **Scopes**: Security configuration; malware protection

    Returns information about available content types for malware protection. Each malware policy includes a set of content types to which the policy's actions are applied.

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name="Documentation")
    malware_content_types = akamai.get_app_sec_malware_content_types(config_id=configuration.config_id)
    pulumi.export("malwareContentTypesOutput", malware_content_types.output_text)
    pulumi.export("malwareContentTypesJson", malware_content_types.json)
    ```
    ## Output Options

    The following options can be used to determine the information returned, and how that returned information is formatted:

    - `output_text`. Tabular report showing the available content types.
    - `json`. JSON-formatted list of the available content types.


    :param int config_id: . Unique identifier of the security configuration associated with the content types.
    """
    ...
